// trig.h : Declaration of the Ctrig

#ifndef __TRIG_H_
#define __TRIG_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// Ctrig
class ATL_NO_VTABLE Ctrig : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Ctrig, &CLSID_trig>,
	public IDispatchImpl<Itrig, &IID_Itrig, &LIBID_ATLTRIGLib>,
	public IDispatchImpl<Iarc, &IID_Iarc, &LIBID_ATLTRIGLib>
{
public:
	Ctrig()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TRIG)

BEGIN_COM_MAP(Ctrig)
	COM_INTERFACE_ENTRY(Itrig)
	COM_INTERFACE_ENTRY(Iarc)
	COM_INTERFACE_ENTRY2(IDispatch, Itrig)
END_COM_MAP()

// Itrig
public:
	STDMETHOD(ATLtan)(double x, double * r);
	STDMETHOD(ATLcos)(double x, double * r);
	STDMETHOD(ATLsin)(double x, double * r);

	STDMETHOD(ATLasin)(double x, double *r);
	STDMETHOD(ATLacos)(double x, double *r);
	STDMETHOD(ATLatan)(double x, double *r);
};

#endif //__TRIG_H_
