// trigX.h : Declaration of the CtrigX

#ifndef __TRIGX_H_
#define __TRIGX_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CtrigX
class ATL_NO_VTABLE CtrigX : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CtrigX, &CLSID_trigX>,
	public IDispatchImpl<ItrigX, &IID_ItrigX, &LIBID_ATLTRIGXLib>
{
public:
	CtrigX()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TRIGX)

BEGIN_COM_MAP(CtrigX)
	COM_INTERFACE_ENTRY(ItrigX)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ItrigX
public:
	STDMETHOD(ATLtanX)(double x, double * r);
	STDMETHOD(ATLcosX)(double x, double * r);
	STDMETHOD(ATLsinX)(double x, double * r);
};

#endif //__TRIGX_H_
